<?php // Include only
if (!defined ('BOOT')) exit ('No bootstrap.  Exiting.');

/*
OekakiPoteto Ban Script
Made for Ranmaguy's Oekaki Poteto system by Travis Skare, travissk@yahoo.com

Wax Poteto modifications Copyright Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 5.8.2 - Last modified 12/26/2010

TO INSTALL:
- Upload this file and two text files to the same directory.
	hosts.txt - hostnames you want to ban.
	ips.txt - ips you want to ban.
- Use this file as an include on necessary pages.
*/


// Init
$hosts_file = 'hosts.txt';
$ips_file   = 'ips.txt';



// Parse hosts
if (!$flags['owner'] && !empty ($hostname)) {

	// No need if host lookup is turned off
	if (! (defined ('DISABLE_DNS_HOST_LOOKUP') && DISABLE_DNS_HOST_LOOKUP)) {
		if (filesize ($hosts_file) > 0) {
			// File for hostnames
			$fp = fopen ($hosts_file, 'r');
			if (!$fp) {
				@db_close();
				echo 'WARNING: hosts.txt cannot be opened!';
				exit;
			} else {
				// File is open and there are more names.
				while (!feof ($fp)) {
					// Assign current name to test variable.
					$buffer = trim (fgets ($fp, 4096));

					if (!empty ($buffer)) {
						// Check for comment
						$pos = strpos ($buffer, '(');
						if ($pos !== FALSE) {
							$buffer = trim (substr ($buffer, 0, $pos));
						}

						$pos = strpos ($buffer, '*');
						if ($pos === FALSE) {
							// asterisk not found.
							// use the old string compare.
							if ($buffer == $hostname)
							{
								// Just a plug for our favorite people :)
								fclose ($fp);
								@db_close();
								header('Location: banned.php');
								exit;
							}
						} else {
							// There was an asterisk.
							// $pos contains the first (and only) occurance
							// of an asterisk, so we can compare the rightmost
							// positions of the strings.

							// Step one: see how many characters are to the right of the *.
							// Length of string: strlen($buffer);
							// First position of asterisk: $pos
							// Number of characters to the right of the *:
							//	(strlen($buffer)-($pos+1));
							$rightmost = strlen ($buffer) - ($pos + 1);
							
							// Compare rightmost parts of the two strings.
							if (substr ($buffer, strlen ($buffer) - $rightmost) == substr ($hostname, strlen ($hostname) - $rightmost)) {
								// Just a plug for our favorite people :)
								fclose ($fp);
								@db_close();
								header('Location: banned.php');
								exit;
							}
						}
					}
				}
				fclose ($fp);
			}
		}
	}
}



// Parse IPs
if (!$flags['owner']) {
	if (filesize ($ips_file) > 0) {
		$fp = fopen ($ips_file, 'r');
		if (!$fp) {
			@db_close();
			exit ('WARNING: ips.txt cannot be opened!');
		} else {
			// File is open and there are more ips
			while (!feof ($fp)) {
				// Assign current name to test variable.
				$buffer = trim (fgets ($fp, 256));

				if (!empty ($buffer)) {
					// Check for comment
					$pos = strpos ($buffer, '(');
					if ($pos !== FALSE) {
						$buffer = trim (substr ($buffer, 0, $pos));
					}

					$pos = strpos ($buffer, '*');
					if ($pos === false) {
						// asterisk not found.
						// use the old string compare.
						if ($buffer == $address) {
							// Just a plug for our favorite people :)
							fclose ($fp);
							@db_close();
							header('Location: banned.php');
							exit;
						}
					} else {
						// Asterisk found.
						// Position will be how many characters are to the left.
						// This makes things easy.
						if (substr ($buffer, 0, $pos) == substr ($address, 0, $pos)) {
							// Just a plug for our favorite people :)
							fclose ($fp);
							@db_close();
							header('Location: banned.php');
							exit;
						}
					}
				}
			}
			fclose ($fp);
		}
	}
}
?>